#ifndef SCOPE_QUERY_H_
#define SCOPE_QUERY_H_

#include <unity/scopes/SearchQueryBase.h>
#include <unity/scopes/ReplyProxyFwd.h>
#include <unity/scopes/OptionSelectorFilter.h>
#include "scope.h"

namespace scope {

/**
 * Represents an individual query.
 *
 * A new Query object will be constructed for each query. It is
 * given query information, metadata about the search, and
 * some scope-specific configuration.
 */
class Query: public unity::scopes::SearchQueryBase {
public:
    Query(const Scope& scope,
          const unity::scopes::CannedQuery &query,
          const unity::scopes::SearchMetadata &metadata);

    ~Query() = default;

    void cancelled() override;

    void run(const unity::scopes::SearchReplyProxy &reply) override;

private:
    static void replace_all(std::string &data, const std::string &old_value, const std::string &new_value);
    unity::scopes::Variant subst(const unity::scopes::Variant& input, int count) const;
    std::string subst(const std::string& pattern, int count) const;

    void generate_results(unity::scopes::SearchReplyProxy const& reply);

    const Scope& scope_;
};

}

#endif // SCOPE_QUERY_H_
