#ifndef SCOPE_SCOPE_H_
#define SCOPE_SCOPE_H_

#include <unity/scopes/ScopeBase.h>
#include <unity/scopes/QueryBase.h>
#include <unity/scopes/ReplyProxyFwd.h>
#include <unity/scopes/QueryBase.h>
#include <unity/scopes/PreviewQueryBase.h>
#include <unity/scopes/Variant.h>
#include <list>

namespace scope {

struct CategoryDefinition
{
    std::string id;
    std::string renderer;
    std::string name;
    int result_count;
    std::list<std::pair<std::string, unity::scopes::Variant>> result_values;

    CategoryDefinition(): result_count(0) {
    }
};

class Scope: public unity::scopes::ScopeBase {
public:
    /**
     * Called once at startup
     */
    void start(std::string const&) override;

    /**
     * Called at shutdown
     */
    void stop() override;

    /**
     * Called each time a new preview is requested
     */
    unity::scopes::PreviewQueryBase::UPtr preview(const unity::scopes::Result&,
                                                  const unity::scopes::ActionMetadata&) override;

    /**
     * Called each time a new query is requested
     */
    unity::scopes::SearchQueryBase::UPtr search(
            unity::scopes::CannedQuery const& q,
            unity::scopes::SearchMetadata const&) override;

    void load_config(const std::string& scope_id);

    std::list<CategoryDefinition> category_defs;
    std::string scope_dir;
};

}

#endif // SCOPE_SCOPE_H_
